#!/bin/sh
#interfaz Xdialog para arrancar flrec, grabar desde mesa mezclas y
# guardar el output en el ordenata como ogg/mp3/wav (PARA CUAS)
#Utiliza flrec/sox para la grabacion (flrec-cunyas hack),
# di para el uso del disco, bc para calcular el espacio en disco,
# y vorbiscomment|id3v2 para meter comentarios en el ogg|mp3.
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Variables utiles (paths y tal):
# $DIRKUNYAS con barra al final porque xdialog tb le pone una. Ojo a los paths al utilizar la variable
#DIRKUNYAS=/home/martintxo/pruebas/
DIRKUNYAS=/home/garraxi/Biltegi/Kunyas/kunyas/
DIRTEMP=/tmp
#DIPATH=/home/martintxo/pruebas/
DIPATH=/home/garraxi/Biltegi/Kunyas

#Variable que guarda informacion sobre espacio libre en disco:
# Con df problema: segun baja el tamao disponible, cambia el output de df y cut puede no encontrar el valor
# solucion: utilizar di (pero hace honor a LANG y da decimales separados por comas, y eso no gusta a bc)
DISCO="`export LANG=en; di -f v -n -m -w 0 $DIPATH; export LANG=es_ES`"

#Con la tasa de bits a la que grabamos con flrec/sox (90 kb/s) una hora ocupa aprox 30 Mb.
#Por lo que en sdc1 (8.624Mb) pueden llegar a caber unas 280 horas de cuas.
#'bc' para calculo, 'expr' no decimales: http://www.webservertalk.com/archive109-2007-9-2041143.html
HORAS=$(echo "scale=1; $DISCO/30" | bc)

#GUI para dar el nombre del archivo donde se graba:
GUI=`Xdialog --wmclass "grabar" --title "Grabar CUAS" \
        --backtitle "En el disco duro donde se guardan las cuas (sdc1) quedan: $DISCO Mb libres.\nEsto equivale aproximadamente a $HORAS horas de grabacin." \
	--stdout --left --separator "|" \
	--check "Guardar en carpeta diferente a ~/Biltegi/Kunyas/kunyas/ (util para editar kua con audacity)" "off" \
	--inputbox "Escribe un nombre descriptivo para la CUA.\n * Ejemplo: Manifa_presos-05-02-08\n * Utiliza un nombre sencillo, con pocas palabras, y sin letras raras ( \"'s\" ), ni espacios.\n * Si la cua es para una convocatoria pon la fecha del da despus en formato 05-02-08.\n * El archivo se guarda en ~/Biltegi/Kunyas/kunyas/.\n    NO LO MUEVAS DE AH (es la carpeta desde la que se emiten automticamente).\n * Si crees que hay poco espacio para grabar cuas (lo dice aqu arriba)\n    avisa a l*s admins (en la asamblea o en garraxi@sindominio.net).\n         -------------------\n * Tras dar al OK te aparecer la ventana del programa grabador.\n * Haz click en el botn pequeo que hay encima del que tiene un crculo rojo.\n * Despus haz click en el botn del crculo rojo y EMPEZAR A GRABAR.\n         -------------------\n * Cuando acabes de grabar haz click en el botn del cuadrado verde (finaliza la grabacin).\n * Despus cierra el programa con la \"x\" de arriba a la derecha.\n * Aparecer una ventana informativa similar a esta, sigue sus instrucciones.\nGracias :-D!!." 0 0 "" `

#Quita a $GUI el output de --check que aparece despues de un espacio y puede ser checked o unchecked:
# Con sed: GUI2=`echo "$GUI" | sed 's/[u]\?[n]\?checked//i'`
GUI2=`echo "$GUI" | gawk 'BEGIN{IGNORECASE=1} { gsub (/'[u]?[n]?checked'/, ""); print }' 2> /dev/null`

#Cuando NO se rellena la casilla, sale sin decir nada (igual si se cancela, o se quita con el boton "x" del windowmanager):
if [ "$GUI2" = "" ];then
  exit;
fi

for i in $GUI ; do
       case $i in
 	  checked)
	    #Cambia el valor de $DIRKUNYAS para utilizar otro dir para cuas a editar
	    DIRKUNYAS=`Xdialog --wmclass "soma" --title "Selecciona carpeta" --stdout \
       --backtitle "Elige la carpeta alternativa donde quieres guardar la cua para luego editarla.\nDespus dale al OK y aparecer el programa grabador." \
        --dselect "$DIPATH" 0 0`;
              case $? in
                0)
                ;;
                1)
                 exit;;
                esac 
           ;;
	 unchecked)
	   ;;
       esac
done

#Cuando el fichero que queremos grabar ya existe de antes, da mensaje de error y arranca de nuevo el programa:
# OOPS: no permite guardar 2 cuas con el mismo nombre, aunque les cambiemos de extension.
if [ -f "$DIRKUNYAS$GUI2.ogg" ] || [ -f "$DIRKUNYAS$GUI2.mp3" ] || [ -f "$DIRKUNYAS$GUI2.wav" ];then
 Xdialog --wmclass "grabar" --title "Grabar CUAS" \
	--infobox "OOOPS!!\nEl nombre de la cua que has elegido ya existe.\nIntentalo de nuevo con otro nombre." 0 0 5000;
 exec flrec-grabacunya.sh;
fi

#Cuando SI se rellena la casilla, arranca el flrec-cunyas con las opciones adecuadas, listo para grabar:
#Graba la cua en dir /tmp para que no exista durante su grabacion y asi un Somad arrancado no pueda
# comenzar a emitir la cua que se esta grabando en ese momento.
#Esto solo era imp. para programas, pero implementado tb. para cuas porsia :-D.
if [ "$GUI2" != "" ];then
  #Variable para meter la fecha de la cua en los comentarios del ogg/mp3:
  DATE=`date +%d/%m/%Y_%H:%M:%S`;
  flrec-cunyas -q "$DIRTEMP/$GUI2";
    #Cuando no se ha grabado nada, o el archivo creado tiene tamao 0 bytes, sale sin decir nada, si no continua:
    if  [ ! -f "$DIRTEMP/$GUI2" ] || [ ! -s "$DIRTEMP/$GUI2" ] ;then
      exit
    fi
  FORMAT=`file --mime --brief "$DIRTEMP/$GUI2"`

  if [ "$FORMAT" = "application/ogg" ]; then
   vorbiscomment -a -t "TITLE=Cunya \"$GUI2\", grabada el `echo "$DATE" | cut --delimiter="_" -f 1 -s`" -t "ARTIST=Realizador@s de \"$GUI2\"" -t "DATE=$DATE" -t "COPYRIGHT=Las personas que han grabado la cunya \"$GUI2\"" -t "LICENSE=Se permite la copia, modificacin y distribucin de esta obra bajo los trminos de la licencia de Creative Commons \"Reconocimiento-CompartirIgual\": http://creativecommons.org/licenses/by-sa/2.5/es/" -t "ORGANIZATION=Garraxi Irratia" -t "CONTACT=http://www.sindominio.net/garraxi/" "$DIRTEMP/$GUI2"
   EXT="ogg"  
  elif [ "$FORMAT" = "audio/mpeg" ]; then
   id3v2 -t "Cunya \"$GUI2\", grabada el `echo "$DATE" | cut --delimiter="_" -f 1 -s`" -a "Realizador@s de \"$GUI2\"" --TDAT "$DATE" -y `echo "$DATE" | cut --delimiter="_" -f 1 -s | cut --delimiter="/" -f 3 -s` --WCOP "Las personas que han grabado la cunya \"$GUI2\"" -c "Se permite la copia, modificacin y distribucin de esta obra bajo los trminos de la licencia de Creative Commons \"Reconocimiento-CompartirIgual\"." --TPUB "Garraxi Irratia" --WPUB "http://www.sindominio.net/garraxi/" "$DIRTEMP/$GUI2"
   EXT="mp3"
  elif [ "$FORMAT" = "audio/x-wav" ]; then
   EXT="wav"
  else
   EXT="formato.desconocido"
  fi
  
   #Al finalizar la grabacion, mueve el archivo grabado al lugar adecuado (ojo $DIRKUNYAS tiene / final):   
   mv "$DIRTEMP/$GUI2" "$DIRKUNYAS$GUI2.$EXT";
 #GUI con la info final:
   Xdialog --wmclass "soma" --title "Grabar CUAS" --ok-label "FIN" --left  --timeout 40 \
        --msgbox "          BIEEEN :-D!!.\nHas terminado de grabar la cua y ha quedado guardada en:\n    "$DIRKUNYAS"$GUI2".$EXT"\nAhora:\n * Si la cua est guardada en la carpeta normal de cuas (~/Biltegi/Kunyas/kunyas/)\n   y quieres que est disponible INMEDIATAMENTE para su emisin,\n   puedes hacer doble click sobre el cono de abajo a la izquierda del escritorio\n   que sirve para que Somad relea los archivos que tiene para emitir y se entere de los cambios.\n * Si la cua NO est guardada en la carpeta normal de cuas\n   edtala como quieras y despus muvela a la carpeta de cuas (~/Biltegi/Kunyas/kunyas/);\n   despus puedes hacer lo de releer los archivos de Somad.\nSi hubiera algn problema comntalo en la asamblea, o en garraxi@sindominio.net.\nGracias :-D!!" 0 0;

 exit $?

fi
